﻿// ** AUTO-UI IMPORT STATEMENTS **
// ** END AUTO-UI IMPORT STATEMENTS **



import hr.skolskaknjiga.wordshuffle.*;

class hr.skolskaknjiga.WordShuffle extends MovieClip {

	public static var CLASS_REF = hr.skolskaknjiga.WordShuffle;
	public static var LINKAGE_ID:String = "WordShuffle";

	///private var EB:EventBroadcaster;
	public var options:Object;
	
	private var sentences:Array;
	private var sentenceTFs:Array;
	private var sentenceMCs:Array;
	
	private var insertLetters:String = "abcdefghij";
	
	private var solvedSentences:Number = 0;

// ** AUTO-UI ELEMENTS **
	private var bravo:MovieClip;
	private var checkBtn:Button;
	private var nextBtn:Button;
// ** END AUTO-UI ELEMENTS **

	//////////////////////////////
	//////// CONSTRUCTOR /////////
	//////////////////////////////
	public function WordShuffle() {
		///EB = EventBroadcaster.getInstance();
		_global.shuffleMain = this;
		
		options = new Object();
		sentences = new Array();
		sentenceTFs = new Array();
		sentenceMCs = new Array();
		
	}
	private function onLoad() {
		scanAndCreate();
		nextBtn._visible = false;
		///trace(sentences);
	}

	//////////////////////////////
	/////////// PUBLIC ///////////
	//////////////////////////////
	public function solved(s:Sentence):Void {
		if (Boolean(options.show_results_immediatelly)) {
			s.showCorrect();
			checkAnswers(false);
		}
	}
	//////////////////////////////
	/////////// PRIVATE //////////
	//////////////////////////////
	private function scanAndCreate():Void {
		for (var i:Number = 1; i > 0; i++) {
			var sentTF:TextField;
			if (!this["recenica" + i]) break;
			else {
				sentTF = this["recenica" + i];
				sentences.push(sentTF.text);
				sentenceTFs.push(sentTF);
				
				var sentClass:String;
				if (this["pobrkana" + i] != null) {
					sentClass = "PresetSentence";
				}
				else if (this["ubaci" + i] != null || this["ubaci" + i + "a"] != null) {
					sentClass = "InsertSentence";
				}
				else {
					sentClass = "RandomSentence";
				}
				var sentMC:Sentence = Sentence(this.attachMovie(sentClass, "sentence" + i, this.getNextHighestDepth()));
				sentMC._x = sentTF._x;
				sentMC._y = sentTF._y;
				sentMC.index = i;
				sentMC.generateWords(sentTF);
				switch (sentClass) {
					case "PresetSentence":
						PresetSentence(sentMC).preset(this["pobrkana" + i]);
					break;
					
					case "InsertSentence":
						var inserts:Array = new Array();
						if (this["ubaci" + i] != null) inserts.push(this["ubaci" + i]);
						for (var j:Number = 0; j < insertLetters.length; j++) {
							var ltt:String = insertLetters.substr(j, 1);
							if (this["ubaci" + i + ltt] != null) inserts.push(this["ubaci" + i + ltt]);
						}
						InsertSentence(sentMC).makeInserts(inserts);
					break;
					
					case "RandomSentence":
					
					break;
				}
				sentTF._visible = false;
			}
			sentenceMCs.push(sentMC);
		}
	}
	
	
	private function checkAnswers(showWrongs:Boolean):Void {
		///trace("checkAnswers");
		solvedSentences = 0;
		for (var i:Number = 0; i < sentenceMCs.length; i++) {
			var s:Sentence = sentenceMCs[i];
			if (s.correct) {
				s.showCorrect();
				solvedSentences++;
			}
			else {
				if (showWrongs) s.showWrong();
			}
		}
		if (solvedSentences == sentences.length) {
			goBravo();
		}
	}
	
	private function goBravo():Void {
		bravo.gotoAndStop("bravo");
		nextBtn._visible = true;
	}

} 